//Guitar Hero Toy
//By: Gabriel St. Onge
//Date started: 09/22/19
//Submission date: 09/30/19
//Description: Make a toy that plays like guitar hero. You lose when you run out of HP
//The game gets faster the better you play

//Declare all our variables
int score = 0;
int streak = 0;
int HP = 5;
//The speed randomly starts between 1 and 1.9
float speed = random (1,1.9);
float greenX = 110;
float greenY;
float redX = 170;
float redY;
float blueX = 290;
float blueY;
float yellowX = 230; 
float yellowY; 
boolean keyA;
boolean keyS;
boolean keyD;
boolean keyF;
boolean gameOn = false;

//In the setup we will just need to change
void setup() {
  //The size of the window to 400x400 pixels
  size(400,400);
  //The frameRate to 30
  frameRate(30);
  //and ellipse and rect mode
  ellipseMode(CENTER);
  rectMode(CENTER);
}

void draw() {
  background(50,0,0);
  //if gameon equals false, call menu function
  if (gameOn == false){
    menu();
  }
  //when gameon is true, call the rest of the functions
  else {
    background(50,0,0);
    drawStage();
    drawHUD();
    drawGreen();
    drawRed();
    drawYellow();
    drawBlue();
    hitNote();
    gameOver();
  }
}

void menu() {
  drawPattern();
  //the start button
  stroke(0,100,0);
  fill(0,255,0);
  rect(width/2,height/2,120,60);
  fill(0,50,0);
  textSize(30);
  text("START",155,210);
  textSize(50);
  fill(255);
  //The title
  text("Guitar Zero",60,100);
  textSize(20);
  //My name
  text("By: Gabriel St. Onge", 100, 150);
  //Controls
  text("Controls- A, S, D, F",100,350);
  //if the mouse hovers over the start button, it changes colour and gets darker
  if (mouseX >= 140 && mouseX <= 260 && mouseY >= 170 && mouseY <= 230){
    rect(width/2,height/2,120,60);
    fill(0,50,0);
    textSize(30);
    text("START",155,210);
  }
}
  
void drawStage() {
  //The neck of the guitar
  stroke(0);
  fill(170);
  quad(80,400,320,400,320,0,80,0);
  fill(0);
  quad(80,400,320,400,320,360,80,360);
  //the bars
  fill(0);
  strokeWeight(2);
  line(110,390,110,0);
  line(170,390,170,0);
  line(290,390,290,0);
  line(230,390,230,0);
  strokeWeight(1);
  
  //The individual keys at the bottom
  fill(255);
  strokeWeight(2);
  textSize(14);
  
  //Green Key
  stroke(0,255,0);
  ellipse(110,380,55,30);
  
  //Red Key
  stroke(255,0,0);
  ellipse(170,380,55,30);
  
  //Yellow Key
  stroke(255,255,0);
  ellipse(230,380,55,30);
  
  //Blue Key
  stroke(0,0,255);
  ellipse(290,380,55,30);
  
  //text to show the player what to press
  fill(0);
  text("A",105,385);
  text("S",165,385);
  text("D",225,385);
  text("F",285,385);
}

void drawHUD(){
  //The HUD for the left side of the screen
  fill(255);
  textSize(18);
  //The HUD for the score
  text("Score:",10,25);
  text(score,10,45);
  
  //the HUD for the streak
  text("Streak:",10, 80);
  text(streak, 10, 100);

//the HUD for the right side of the screen

  //The HUD for the players HP
  text("HP:",320,25);
  text(HP,320,45);
  
  //the HUD for the current speed
  text("Speed:",320, 80);
  text(speed, 320, 100);
}

//The function to draw green notes
void drawGreen(){
  //Create a green ellipse
  fill(0,255,0);
  stroke(0,100,0);
  strokeWeight(2);
  ellipse(greenX,greenY,55,30);
  //it stays along greenX and moves downwards, increasing in speed 
  greenY += speed + 2.5;
  //if the green note passes through the bottom
  if (greenY >= 430){
    //lose some hp
    HP -= 1;
    //reset streak
    streak = 0;
    //bring it back up to the top
    greenY = 0;
    //if speed is between 1 and 1.399 when this happens
    if (speed >= 1 && speed <= 1.399){
      //set it to one (the lowest)
        speed = 1;
    }
    //otherwise decrease speed by .4
    else {
        speed -= .4;
    }
  }
}

//The function to draw red notes
//The next three functions are the exact same as the last except they have different values for fill as well as different variables(redX instead of greenX,etc.)
//For that reason, I won't explain them each time since that would be redundant so please refer to the block of code above for guidance
void drawRed(){
  fill(255,0,0);
  stroke(100,0,0);
  strokeWeight(2);
  ellipse(redX,redY,55,30);

  redY += speed + 4.5;
  if (redY >= 430){
    HP -= 1;
    streak = 0;
    redY = 0;
    if (speed >= 1 && speed <= 1.399){
        speed = 1;
    }
    else {
        speed -= .4;
    }
  }
}

//The function to draw yellow notes
void drawYellow(){
  fill(255,255,0);
  stroke(100,100,0);
  strokeWeight(2);
  ellipse(yellowX,yellowY,55,30);

  yellowY += speed + 3;
  if (yellowY >= 430){
    HP -= 1;
    streak = 0;
    yellowY = 0;
    if (speed >= 1 && speed <= 1.399){
        speed = 1;
    }
    else {
        speed -= .4;
    }
  }
}

//The function to draw blue notes
void drawBlue(){
  fill(0,0,255);
  stroke(0,0,100);
  strokeWeight(2);
  ellipse(blueX,blueY,55,30);

  blueY += speed + 2;
  if (blueY >= 430){
    HP -= 1;
    streak = 0;
    blueY = 0;
    if (speed >= 1 && speed <= 1.399){
        speed = 1;
    }
    else {
        speed -= .4;
    }
  }
}

//The function to hit notes successfully
void hitNote(){
  //if green y is touching the bottom key when w is hit
  if (greenY >= 370 && greenY <= 400 && keyA == true){
    //increase score and streak
    score += 1;
    streak += 1;
    //and if speed is between 3.4 and 3.5
    if (speed >= 3.4 && speed <= 3.5){
      //Raise it to the max
      speed = 3.5;
    }
    //otherwise increase it by .1
    else {
      speed += .1;
    }
    //reset the notes position
    greenX = 110;
    greenY = 0;
  }
  if (redY >= 370 && redY <= 400 && keyS == true){
    //increase score and streak
    score += 1;
    streak += 1;
    //and increase speed if it hasn't hit max
    if (speed >= 3.4 && speed <= 3.5){
      speed = 3.5;
    }
    else {
      speed += .1;
    }
    //reset the notes position
    redX = 170;
    redY = 0;
  }
   if (yellowY >= 370 && yellowY <= 400 && keyD == true){
    //increase score and streak
    score += 1;
    streak += 1;
    //and increase speed if it hasn't hit max
    if (speed >= 3.4 && speed <= 3.5){
      speed = 3.5;
    }
    else {
      speed += .1;
    }
    //reset the notes position
    yellowX = 230;
    yellowY = 0;
  }
   if (blueY >= 370 && blueY <= 400 && keyF == true){
    //increase score and streak
    score += 1;
    streak += 1;
    //and increase speed if it hasn't hit max
    if (speed >= 3.4 && speed <= 3.5){
      speed = 3.5;
    }
    else {
      speed += .1;
    }
    //reset the notes position
    blueX = 290;
    blueY = 0;
  }
}

//The function to lose health and die
boolean gameOver(){
  //if HP reaches 0
  if (HP <= 0){
    //set gameOn to false
    gameOn = false;
    //reset score and streak
    score = 0;
    streak = 0;
    //set speed to one (the lowest)
    speed = 1;
    //bring the user back to the menu
    menu();
    //reset HP to 5
    HP = 5;
    //reset the position of the notes
    greenY = 0;
    redY = 0;
    yellowY = 0;
    blueY = 0;
  }
  return gameOn;
}

//If the user clicks the mouse over the start button, the game will start
void mouseClicked() {
  if (mouseX >= 140 && mouseX <= 260 && mouseY >= 170 && mouseY <= 230){
    gameOn = true;
  }
}

//If the keys "ASDF" are pressed, there will be some kind of visual feedback in the form of the bottom keys flashing gray 
//The variables keyA,keyS,keyD,keyF will also be set to true
void keyPressed() {
  fill(175);
  if (key == 'a') {
    keyA=true;
    ellipse(110,380,55,30);
  }
  else if (key == 's') {
    keyS=true;
    ellipse(170,380,55,30);
  }
  else if (key == 'd') {
    keyD=true;
    ellipse(230,380,55,30);
  }
  else if (key == 'f') {
    keyF=true;
    ellipse(290,380,55,30);
  }
}

//when the keys are release, the variable becomes false once more
void keyReleased() {
  if (key == 'a') {
    keyA=false;
  }
  else if (key == 's') {
    keyS=false;
  }
  else if (key == 'd') {
    keyD=false;
  }
  else if (key == 'f') {
    keyF=false;
  }
}

//the necessary loop
void drawPattern() {
  //for i in a range of 400
  for (int i = 0 ; i < 400 ; i+= 20) {
    //draw a green rectangle 20 values of x apart from one another
    fill(0,50,0);
    rect(i, 0, 5, 800);
  }
}
